/*****************************************************************************/
/*                                                                           */
/* Author: Michael C. Nechyba                                                */
/* Last modified: 02/13/2004                                                 */
/*                                                                           */
/* File: "dwt_util.h"                                                        */
/*                                                                           */
/*****************************************************************************/

#define MAX_DWT_FILTER_LENGTH 12

#define LH_BAND 1
#define HL_BAND 2
#define HH_BAND 3
#define LL_BAND 4

/*****************************************************************************/

/* DWT definitions */

extern int haar_filter(double *lpf);
extern int daubechies_filter(double *lpf, int n);
extern int highpass_filter(double *hpf, double *lpf, int n);
extern int inverse_filter(double *ilpf, double *lpf, int n);
extern int setup_forward_filters(double *lpf, double *hpf, int nf);
extern int setup_inverse_filters(double *ilpf, double *ihpf, int nf);

extern int dwt1D_level(double *w, double *x, int nx, 
		       double *lpf, double *hpf, int nf,
		       int level);

extern int dwt1D(double *x, int nx,
		 double *lpf, double *hpf, int nf,
		 int level);

extern int idwt1D_level(double *x, double *w, int nw, 
			double *lpf, double *hpf, int nf,
			int level);

extern int idwt1D(double *w, int nw,
		  double *lpf, double *hpf, int nf,
		  int level);

extern int dwt2D(double **x, int nx, double *lpf, int nf, int level);
extern int idwt2D(double **w, int nw, double *lpf, int nf, int level);

extern int max_levels(int n, int nf);
extern int zero_coefficients2D(double **w, int n, double thresh);

extern int extract_band(double **b, int wb, int wlevel, double **w, int nw);
extern int extract_submatrix(double **sm, double **m,
			     int xs, int ys, int xe, int ye);
