/*****************************************************************************/
/*                                                                           */
/* Author: Michael C. Nechyba                                                */
/* Last modified: 02/15/2004                                                 */
/*                                                                           */
/* File: "ppm_util.h"                                                        */
/*                                                                           */
/*****************************************************************************/

#ifndef X_DIM_MAX
#define X_DIM_MAX 640
#endif

#ifndef Y_DIM_MAX
#define Y_DIM_MAX 480
#endif


/*****************************************************************************/

typedef struct ppm_image_struct {
  unsigned char p[X_DIM_MAX][Y_DIM_MAX][3];
  int xdim;
  int ydim;
} PPM;

/*****************************************************************************/

extern int read_ppm_file(char *file, PPM *image);
extern int write_ppm_file(char *file, PPM *image);
extern double convert_one_pixel(unsigned char *pixel);
extern double **convert_ppm_to_double(double **x, PPM *image, int alloc);
extern int convert_double_to_ppm(PPM *image, double **x);





